#ifndef __ABSTRACTFATOLRGCONVERTER_H__
#define __ABSTRACTFATOLRGCONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/LeftRegularGrammar.h>
#include <AlibException.h>

#include "../../include/macros.h"
#include "../AbstractFAtoRGConverter.h"

namespace conversions
{

/**
 * Abstract finite automata to right regular grammar.
 */
class AbstractFAtoLRGConverter : public AbstractFAtoRGConverter
{
public:
    /**
     * @return left regular grammar equivalent to source automata.
     */
    virtual grammar::LeftRegularGrammar convert( ) = 0;
    virtual ~AbstractFAtoLRGConverter( void );

protected:
    /**
     * New left regular grammar.
     */
    grammar::LeftRegularGrammar m_grammar;

    /**
     * @param automaton Original FSM.
     */
    AbstractFAtoLRGConverter( const automaton::FSM & automaton );
};

} /* namespace conversions */

#endif /* __ABSTRACTFATOLRGCONVERTER_H__ */
