#ifndef __FATOLRGCONVERTER_H__
#define __FATOLRGCONVERTER_H__

#include <grammar/Regular/LeftRegularGrammar.h>
#include <automaton/FSM/FSM.h>

#include "AbstractFAtoLRGConverter.h"

namespace conversions
{

/**
 * Finite automata to right regular grammar converter.
 * Source: My own :)
 */
class FAtoLRGConverter: public AbstractFAtoLRGConverter
{
public:
    /**
     * @param automaton Original automaton.
     */
    FAtoLRGConverter( const automaton::FSM & automaton );

    ~FAtoLRGConverter( void );

    /**
     * Performs conversion.
     * @return left regular grammar equivalent to source automata.
     */
    grammar::LeftRegularGrammar convert( void );

protected:
    /**
     * New left regular grammar.
     */
    grammar::LeftRegularGrammar m_grammar;
};

} /* namespace conversions */

#endif /* __FATOLRGCONVERTER_H__ */
