#ifndef __ABSTRACTRGTOFACONVERTER_H__
#define __ABSTRACTRGTOFACONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include "../include/macros.h"
#include "../abstract/Conversion.h"

namespace conversions
{

/**
 * Abstract regular grammar to finite state machine conversion.
 */
class AbstractRGtoFAConverter : public Conversion
{
public:
    /**
     * @return FSM equivalent to source grammar.
     */
    virtual automaton::FSM convert( void ) = 0;
    virtual ~AbstractRGtoFAConverter( void );

protected:
    AbstractRGtoFAConverter( void );

    /**
     * New automaton.
     */
    automaton::FSM m_automaton;
};

} /* namespace conversions */

#endif /* __ABSTRACTRGTOFACONVERTER_H__ */
