/*
 * AbstractLRGtoFAConverter.h
 *
 *  Created on: 16. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTLRGTOFACONVERTER_H_
#define ABSTRACTLRGTOFACONVERTER_H_

#include <grammar/Regular/LeftRegularGrammar.h>

#include "../AbstractRGtoFAConverter.h"

namespace conversions
{

/**
 * Abstract left regular grammar to finite automata conversion.
 */
class AbstractLRGtoFAConverter: public AbstractRGtoFAConverter
{
public:
    ~AbstractLRGtoFAConverter( void );

protected:
    /**
     * @param Source left regular grammar.
     */
    AbstractLRGtoFAConverter( const grammar::LeftRegularGrammar & lrg );

    /**
     * Source grammar.
     */
    const grammar::LeftRegularGrammar m_grammar;

};

} /* namespace conversions */

#endif /* ABSTRACTLRGTOFACONVERTER_H_ */
