#ifndef __RRGTOFACONVERTER_H__
#define __RRGTOFACONVERTER_H__

#include "AbstractRRGtoFAConverter.h"

namespace conversions
{

/**
 * Converts left regular grammar to finite automata.
 * Source: Melichar 2.98
 */
class RRGtoFAConverter : public AbstractRRGtoFAConverter
{
public:
    /**
     * @param grammar Source right regular grammar.
     */
    RRGtoFAConverter( const grammar::RightRegularGrammar & grammar );

    ~RRGtoFAConverter( void );

    /**
     * Performs conversion.
     * @return FSM equivalent to source grammar.
     */
    automaton::FSM convert( void );
};

} /* namespace conversions */

#endif /* __RRGTOFACONVERTER_H__ */
