/*
 * LRGAlgebraic.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef LRGALGEBRAIC_H_
#define LRGALGEBRAIC_H_

#include "../../shared/equations/LeftRegularEquationSolver.h"
#include "AbstractLRGtoREConverter.h"

namespace conversions
{

class LRGAlgebraic: public AbstractLRGtoREConverter
{
public:
    /**
     * @param rg Source left regular grammar.
     */
    LRGAlgebraic( const grammar::LeftRegularGrammar & rg );

    ~LRGAlgebraic( void );

    /**
     * @return regexp equivalent to source left regular grammar.
     */
    regexp::RegExp convert( void );

protected:
    /**
     * Equation solver.
     */
    LeftRegularEquationSolver m_solver;
};

} /* namespace conversions */

#endif /* LRGALGEBRAIC_H_ */
