/*
 * RRGAlgebraic.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef RRGALGEBRAIC_H_
#define RRGALGEBRAIC_H_

#include "../../shared/equations/RightRegularEquationSolver.h"
#include "AbstractRRGtoREConverter.h"

namespace conversions
{

class RRGAlgebraic: public AbstractRRGtoREConverter
{
public:
    /**
     * @param rg Source right regular grammar.
     */
    RRGAlgebraic( const grammar::RightRegularGrammar & rg );

    ~RRGAlgebraic( void );

    /**
     * @return regexp equivalent to source right regular grammar.
     */
    regexp::RegExp convert( void );

protected:
    /**
     * Equation solver.
     */
    RightRegularEquationSolver m_solver;
};

} /* namespace conversions */

#endif /* RRGALGEBRAIC_H_ */
