/*
 * GasTexConverter.h
 *
 *  Created on: Jan 1, 2014
 *      Author: Martin Zak
 */

#ifndef GASTEXCONVERTER_H_
#define GASTEXCONVERTER_H_

#include<ostream>
#include<map>
#include<utility>
#include"automaton/FSM/FSM.h"
#include"automaton/PDA/PDA.h"
#include"automaton/TM/TM.h"

using namespace std;
using namespace automaton;

class GasTexConverter {
private:
	static void printTransitionMap( const map<pair<string, string>, string> transitionMap, ostream& out);
	static string checkEpsilon(const string& inputSymbol);
	static string getStackSymbols(const list<Symbol>& stackSymbols);
	static void transitions(const FSM& fsm, ostream& out);
	static void transitions(const PDA& pda, ostream& out);
	static void transitions(const TM& tm, ostream& out);
public:
	static void convert(const Automaton& a, ostream& out);
};

#endif /* GASTEXCONVERTER_H_ */
