#ifndef __REG_EXP_PARSER__
#define __REG_EXP_PARSER__

#include "RegExpLexer.h"

#include "regexp/RegExp.h"
#include "regexp/RegExpElements.h"

class ParseError {
  
};

class RegExpParser {
  RegExpLexer& m_Lexer;
public:
  RegExpParser(RegExpLexer&);
  regexp::RegExp* parse();

private:
  regexp::RegExpElement* Alternation();
  regexp::RegExpElement* AlternationCont(regexp::RegExpElement* left);
  regexp::Alternation* AlternationContCont(regexp::RegExpElement* left);
  
  regexp::RegExpElement* Concatenation();
  regexp::RegExpElement* ConcatenationCont(regexp::RegExpElement* left);
  regexp::Concatenation* ConcatenationContCont(regexp::RegExpElement* left);
  
  regexp::RegExpElement* Factor();
  regexp::RegExpElement* Star(regexp::RegExpElement* elem);

};

#endif
