#ifndef REGEXP_PRINTER_H_
#define REGEXP_PRINTER_H_

#include <iostream>
#include "regexp/RegExp.h"
#include "regexp/RegExpElements.h"

class RegExpPrinter {
  std::ostream& m_Out;
public:
  RegExpPrinter(std::ostream& out);
  void printElement(regexp::RegExpElement* element);
  void printAlternation(regexp::Alternation* alternation);
  void printConcatenation(regexp::Concatenation* concatenation);
  void printIteration(regexp::Iteration* iteration);
  void printSymbol(regexp::RegExpSymbol* symbol);
  void printEpsilon(regexp::RegExpEpsilon* symbol);
  void printEmpty(regexp::RegExpEmpty* symbol);

  void print(regexp::RegExp& regexp);
};

#endif /*REGEXP_PRINTER_H_*/
