#include <iostream>
#include <fstream>
#include "RegExpLexer.h"
#include "RegExpParser.h"
#include "RegExpPrinter.h"

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>

#include "regexp/RegExp.h"
#include "RegExpFactory.h"
#include "AlibException.h"

#include "regexp/RegExp.h"

#define FROM 1
#define TO 2

int fromRegexp(std::istream& in, std::ostream& out) {
  RegExpLexer lexer(in);
  RegExpParser parser(lexer);
  
  regexp::RegExp* result = parser.parse();
  
  out << *result;
  
  return 0;
}

int toRegexp(std::istream& in, std::ostream& out) {
  try {

    regexp::RegExp regexp = regexp::RegExpFactory::fromStream(in);
    RegExpPrinter printer = RegExpPrinter(out);
    printer.print(regexp);

  } catch (alib::AlibException& e) {
    std::cerr << e.getCause() << std::endl;
    return 1;
  }
  return 0;
}

int main(int argc, char* argv[]) {
  
  int fromTo = 0;
  int c;
  
  while (1) {
    static struct option long_options[] = {
      {"from", no_argument,       &fromTo, FROM},
      {"to",   no_argument,       &fromTo, TO},
      {0, 0, 0, 0}
    };
  
    int option_index = 0;
     
    c = getopt_long (argc, argv, "", long_options, &option_index);

    if (c == -1)
      break;
  
    switch (c) {
    case 0:
      break;
    default:
      optind--;
      goto more;
    }
  }
more:

  std::istream* in = &std::cin;
  if(optind != argc) in = new std::ifstream(argv[optind]);

  int res;
  if(fromTo == FROM) {
    res = fromRegexp(*in, std::cout);
  } else if(fromTo == TO) {
    res = toRegexp(*in, std::cout);
  } else {
    std::cerr << "error" << std::endl;
    res = 1;
  }
  
  if(c != -1) delete in;
  return res;
}