#include "Utils.h"

namespace determinization {


void Utils::copyInputAlphabet(const Automaton& source, Automaton& dest)
{
    for (const auto& symbol : source.getInputAlphabet()) {
        dest.addInputSymbol(symbol);
    }
}


bool Utils::containFinalState(const set<State>& states, const Automaton& automaton)
{
    const set<State>& finalStates = automaton.getFinalStates();
    set<State> intersection;
    set_intersection(finalStates.begin(), finalStates.end(), states.begin(), states.end(),
        inserter(intersection, intersection.begin()));
    return intersection.size() > 0;
}


void Utils::copyStackAlphabet(const PDA& source, PDA& dest) {
    for (const auto& symbol : source.getStackAlphabet()) {
        dest.addStackSymbol(symbol);
    }
}


}
