//============================================================================
// Name        : adiff.cpp
// Author      : Honza
// Version     :
// Copyright   : 
// Description :
//============================================================================

#include <iostream>

#include "automaton/UnknownAutomaton.h"
#include "AutomatonFactory.h"
#include "AlibException.h"

using namespace std;
using namespace automaton;
using namespace alib;

#include "AutomatonDiff.h"

int main(int argc, char** argv) {

	UnknownAutomaton automaton1;
	UnknownAutomaton automaton2;

	try {

		if (argc == 2 && string("-h").compare(argv[1]) == 0) {
			cout << "Automaton diff.\nUsage: adiff automaton.xml automaton.xml\n";
			return -1;
		}

		if (argc == 3) {
			automaton1 = AutomatonFactory::fromFile(argv[1]);
			automaton2 = AutomatonFactory::fromFile(argv[2]);
		}

		return AutomatonDiff::diff(automaton1, automaton2);
	} catch (AlibException& e) {
		cout << e.getCause() << endl;
		return 0;
	}
}
