/*
 * diff
 *
 * Usage:   diff [-V] [-t difftype] [diff-options] input1 input2
 *
 * Authors:
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <err.h>
#include <stdlib.h>
#include <sys/stat.h>

#define PROGNAME    "./adiff.%s"
#define VERSION     "0.0.1"
#define USAGE       "adiff [-V] -t difftype [diff-options] input1 input2"

int main(int argc, char *argv[]) {
	if (argc == 2 && (!strcmp(argv[1], "-v") || !strcmp(argv[1], "--version"))) {
		char* program_name = argv[0];
		char* p = NULL;
		if ((p = strrchr(program_name, '/')) != NULL)
			program_name = p + 1;

		printf("%s (%s)\n", program_name, VERSION);
		exit(EXIT_SUCCESS);
	}

	char* difftype = NULL;
	int i, verbose = 0;

	while ((i = getopt(argc, argv, "Vt:")) != -1)
		switch (i) {
		case 'V':
			verbose = 1;
			break;
		case 't':
			difftype = optarg;
			break;
		default:
			optind--;
			goto more;
		}
more:

	if (optind == argc || difftype == NULL) {
		fprintf(stderr, "Usage: %s\n", USAGE);
		return EXIT_FAILURE;
	}
	
	if (verbose)
		argv[--optind] = (char*) "-V";
	
	char* program_name = (char*) malloc(sizeof(PROGNAME) - 3 + strlen(difftype) + 1);
	sprintf(program_name, PROGNAME, difftype);
	
	argv[--optind] = program_name + 2;
	
	struct stat buffer;
	if(stat (program_name, &buffer)) {
		program_name += 2;
	}

	execvp(program_name, argv + optind);
	perror(program_name);
	return EXIT_FAILURE;
}
