/*
 * EpsilonClosure.h
 *
 *  Created on: 16. 1. 2014
 *      Author: tomas
 */

#ifndef EPSILONCLOSURE_H_
#define EPSILONCLOSURE_H_

#include <automaton/FSM/FSM.h>
#include <automaton/State.h>

#include <AlibException.h>

#include <set>
#include <map>
#include <queue>

namespace epsilon
{

class EpsilonClosure
{
public:
    EpsilonClosure( const automaton::FSM & fsm );
    const std::set<automaton::State> & getClosure( const automaton::State & state ) const;

private:
    void closure( const automaton::State & state );

    std::map<const automaton::State, std::set<automaton::State>> m_closure;
    const automaton::FSM & m_fsm;
};

} /* namespace epsilon */

#endif /* EPSILONCLOSURE_H_ */
