/*
 * GrammarPrinter.h
 *
 *  Created on: Nov 5, 2013
 *      Author: martin
 */

#ifndef GRAMMARPRINTER_H_
#define GRAMMARPRINTER_H_

#include <ostream>
#include "Grammar.h"

namespace grammar {

using namespace std;

/**
 * This class contains methods to print XML representation of grammars to the output stream.
 */
class GrammarPrinter {
protected:
	static const string INDENTATION;

	static void printNonTerminalSymbols(const Grammar& grammar, ostream& out, string prefix);
	static void printTerminalSymbols(const Grammar& grammar, ostream& out, string prefix);
	static void printRules(const Grammar& grammar, ostream& out, string prefix);
	static void printRule(const Rule& rule, ostream& out, string prefix);
	static void printSymbol(const Symbol& symbol, ostream& out, string tagName, string prefix);
public:
	/**
	 * Prints XML representation of Grammar to the output stream.
	 * @param grammar Grammar to print
	 * @param out output stream to which print the Grammar
	 */
	static void toXML(const Grammar& grammar, ostream& out);
};

} /* namespace grammar */
#endif /* GRAMMARPRINTER_H_ */
