/*
 * RegExpSymbol.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: martin
 */

#include "RegExpSymbol.h"

namespace regexp {

RegExpSymbol::RegExpSymbol() :
		symbol("") {
}

RegExpSymbol::RegExpSymbol(const string& symbol) :
		symbol(symbol) {
}

RegExpElement* RegExpSymbol::clone() const {
	return new RegExpSymbol(this->symbol);
}

bool RegExpSymbol::operator<(const RegExpElement& other) const {
	return other > *this;
}

bool RegExpSymbol::operator==(const RegExpElement& other) const {
	return other == *this;
}

bool RegExpSymbol::operator>(const RegExpElement& other) const {
	return other < *this;
}


bool RegExpSymbol::operator<(const Concatenation&) const {
	return true;
}

bool RegExpSymbol::operator<(const Alternation&) const {
	return true;
}

bool RegExpSymbol::operator<(const Iteration&) const {
	return true;
}

bool RegExpSymbol::operator<(const RegExpSymbol& other) const {
	return this->symbol < other.symbol;
}

bool RegExpSymbol::operator==(const RegExpSymbol& other) const {
	return this->symbol == other.symbol;
}

bool RegExpSymbol::containsEmptyString() const {
	return false;
}

bool RegExpSymbol::isEmpty() const {
	return false;
}

void RegExpSymbol::getAlphabet( std::set<alphabet::Symbol> & alphabet ) const {
	alphabet.insert( Symbol( this->getSymbol( ) ) );
}

const string& RegExpSymbol::getSymbol() const {
	return this->symbol;
}

} /* namespace regexp */

