/*
 * AlibException.h
 *
 *  Created on: Apr 1, 2013
 *      Author: Martin Zak
 */

#ifndef ALIB_EXCEPTION_H_
#define ALIB_EXCEPTION_H_

#include <exception>
#include <string>

namespace alib {

/**
 * Basic exception from which are derived all other exceptions.
 * Contains reason why the exception occured.
 */
class AlibException : public std::exception {
protected:
	std::string cause;
public:
	AlibException();
	AlibException(const std::string& cause);
	virtual ~AlibException() throw ();

	/**
	 * @return reason why the exception occured
	 */
	const char* what() const throw ();

	/**
	 * @return reason why the exception occured
	 */
	const std::string& getCause() const;
};

} /* namespace alib */

#endif /* ALIB_EXCEPTION_H_ */
