/*
 * Symbol.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Martin Zak
 */

#ifndef SYMBOL_H_
#define SYMBOL_H_

#include <string>
#include <ostream>

namespace alphabet {

/**
 * Represents symbol in an alphabet.
 */
class Symbol {
	std::string symbol;
public:
	/**
	 * Creates new symbol with given name.
	 * @param symbol name of the symbol
	 */
	Symbol(const std::string& symbol);
	Symbol(std::string&& symbol);

	/**
	 * @return name of the symbol
	 */
	const std::string& getSymbol() const;

	bool operator <(const Symbol& other) const;
	bool operator ==(const Symbol& other) const;
	bool operator >(const Symbol& other) const;
	bool operator !=(const Symbol& other) const;

	friend std::ostream& operator<<(std::ostream&, const Symbol&);
};

} /* namespace alphabet */

#endif /* SYMBOL_H_ */
