/*
 * TransitionFSMEpsilon.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "TransitionFSMEpsilon.h"

namespace automaton {

TransitionFSMEpsilon::TransitionFSMEpsilon(const State& from,const State& to) : TransitionFSM(from, to) {
}

bool TransitionFSMEpsilon::isReading(const alphabet::Symbol& symbol) const {
	return false;
}

bool TransitionFSMEpsilon::operator < (const TransitionFSM& other) const {
	return other > *this;
}

bool TransitionFSMEpsilon::operator == (const TransitionFSM& other) const {
	return other == *this;
}

bool TransitionFSMEpsilon::operator > (const TransitionFSM& other) const {
	return other < *this;
}


bool TransitionFSMEpsilon::operator < (const TransitionFSMExtended& other) const {
	return true;
}

bool TransitionFSMEpsilon::operator < (const TransitionFSMSymbol& other) const {
	return true;
}

bool TransitionFSMEpsilon::operator < (const TransitionFSMEpsilon& other) const {
	if(from != other.from) {
		return from < other.from;
	} else {
		return to < other.to;
	}
}


bool TransitionFSMEpsilon::operator == (const TransitionFSMEpsilon& other) const {
	return from == other.from && to == other.to;
}

std::ostream& TransitionFSMEpsilon::operator>>(std::ostream& out) const {
	out << "TransitionFSMEpsilon from = " << this->from
		<< " to = " << this->to;

	return out;
}

} /* namespace automaton */
