/*
 * TransitionFSMEpsilon.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef TRANSITION_FSM_EPSILON_H_
#define TRANSITION_FSM_EPSILON_H_

#include "TransitionFSM.h"
#include <ostream>

namespace automaton {

/**
 * Represents transition rule for FSM.
 */
class TransitionFSMEpsilon : public TransitionFSM {
public:
	/**
	 * Creates new transition with given parameters.
	 * @param from from state
	 * @param to to state
	 */
	TransitionFSMEpsilon(const State& from,const State& to);
	
	virtual bool isReading(const alphabet::Symbol& symbol) const;

	virtual bool operator < (const TransitionFSM& other) const;
	virtual bool operator == (const TransitionFSM& other) const;
	virtual bool operator > (const TransitionFSM& other) const;
	
	virtual bool operator < (const TransitionFSMExtended& other) const;
	virtual bool operator < (const TransitionFSMSymbol& other) const;
	virtual bool operator < (const TransitionFSMEpsilon& other) const;

	virtual bool operator == (const TransitionFSMEpsilon& other) const;
	
	virtual std::ostream& operator>>(std::ostream& out) const;
};

} /* namespace automaton */
#endif /* TRANSITION_FSM_EPSILON_H_ */
