/*
 * TransitionFSMExtended.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: martin
 */

#include "TransitionFSMExtended.h"

namespace automaton {
TransitionFSMExtended::TransitionFSMExtended(const State& from,const regexp::RegExp& input,const State& to) : TransitionFSM(from, to), input(input) {
}


bool TransitionFSMExtended::isReading(const alphabet::Symbol& symbol) const {
	// TODO
	return true; 
}

const regexp::RegExp& TransitionFSMExtended::getInput() const {
	return this->input;
}


bool TransitionFSMExtended::operator < (const TransitionFSM& other) const {
	return other > *this;
}

bool TransitionFSMExtended::operator == (const TransitionFSM& other) const {
	return other == *this;
}

bool TransitionFSMExtended::operator > (const TransitionFSM& other) const {
	return other < *this;
}


bool TransitionFSMExtended::operator < (const TransitionFSMExtended& other) const {
	if(from != other.from) {
		return from < other.from;
	} else if(input != other.input) {
		return input < other.input;
	} else {
		return to < other.to;
	}
}

bool TransitionFSMExtended::operator == (const TransitionFSMExtended& other) const {
	return from == other.from && input == other.input && to == other.to;
}


std::ostream& TransitionFSMExtended::operator>>(std::ostream& out) const {
	out << "TransitionFSMExtended from = " << this->from
		<< " to = " << this->to
		<< " input = " << this->input;

	return out;
}

} /* namespace automaton */
