/*
 * TransitionFSMExtended.h
 *
 *  Created on: Mar 26, 2013
 *      Author: martin
 */

#ifndef TRANSITIONFSMEXTENDED_H_
#define TRANSITIONFSMEXTENDED_H_

#include "TransitionFSM.h"
#include "../../regexp/RegExp.h"
#include <ostream>

namespace automaton {

/**
 * Represents transition rule for FSM.
 */
class TransitionFSMExtended : public TransitionFSM {
	regexp::RegExp input;
public:
	/**
	 * Creates new transition with given parameters.
	 * @param from from state
	 * @param input input regexp
	 * @param to to state
	 */
	TransitionFSMExtended(const State& from,const regexp::RegExp& input,const State& to);

	virtual bool isReading(const alphabet::Symbol& symbol) const;
	
	const regexp::RegExp& getInput() const;

	virtual bool operator < (const TransitionFSM& other) const;
	virtual bool operator == (const TransitionFSM& other) const;
	virtual bool operator > (const TransitionFSM& other) const;
	
	virtual bool operator < (const TransitionFSMExtended& other) const;
	
	virtual bool operator == (const TransitionFSMExtended& other) const;

	std::ostream& operator>>(std::ostream& out) const;
};

} /* namespace automaton */
#endif /* TRANSITIONFSMEXTENDED_H_ */
