/*
 * TransitionFSMSymbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: martin
 */

#include "TransitionFSMSymbol.h"

namespace automaton {

TransitionFSMSymbol::TransitionFSMSymbol(const State& from,const Symbol& input,const State& to) : TransitionFSM(from, to), input(input) {
}

bool TransitionFSMSymbol::isReading(const alphabet::Symbol& symbol) const {
	return this->input == symbol;
}

const Symbol& TransitionFSMSymbol::getInput() const {
	return this->input;
}


bool TransitionFSMSymbol::operator < (const TransitionFSM& other) const {
	return other > *this;
}

bool TransitionFSMSymbol::operator == (const TransitionFSM& other) const {
	return other == *this;
}

bool TransitionFSMSymbol::operator > (const TransitionFSM& other) const {
	return other < *this;
}


bool TransitionFSMSymbol::operator < (const TransitionFSMExtended& other) const {
	return true;
}

bool TransitionFSMSymbol::operator < (const TransitionFSMSymbol& other) const {
	if(from != other.from) {
		return from < other.from;
	} else if(input != other.input) {
		return input < other.input;
	} else {
		return to < other.to;
	}
}

bool TransitionFSMSymbol::operator == (const TransitionFSMSymbol& other) const {
	return from == other.from && input == other.input && to == other.to;
}


std::ostream& TransitionFSMSymbol::operator>>(std::ostream& out) const {
	out << "TransitionFSMSymbol from = " << this->from
		<< " to = " << this->to
		<< " input = " << this->input;

	return out;
}

} /* namespace automaton */
