/*
 * TransitionFSMSymbol.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef TRANSITION_FSM_SYMBOL_H_
#define TRANSITION_FSM_SYMBOL_H_

#include "TransitionFSM.h"
#include "../../alphabet/Symbol.h"
#include <ostream>

namespace automaton {

using namespace alphabet;

/**
 * Represents transition rule for FSM.
 */
class TransitionFSMSymbol : public TransitionFSM {
	Symbol input;
public:
	/**
	 * Creates new transition with given parameters.
	 * @param from from state
	 * @param input input symbol
	 * @param to to state
	 */
	TransitionFSMSymbol(const State& from,const Symbol& input,const State& to);
	
	const Symbol& getInput() const;
	
	virtual bool isReading(const Symbol& symbol) const;

	virtual bool operator < (const TransitionFSM& other) const;
	virtual bool operator == (const TransitionFSM& other) const;
	virtual bool operator > (const TransitionFSM& other) const;
	
	virtual bool operator < (const TransitionFSMExtended& other) const;
	virtual bool operator < (const TransitionFSMSymbol& other) const;

	virtual bool operator == (const TransitionFSMSymbol& other) const;
	
	virtual std::ostream& operator>>(std::ostream& out) const;
};

} /* namespace automaton */
#endif /* TRANSITION_FSM_SYMBOL_H_ */
