/*
 * TransitionPDA.h
 *
 *  Created on: Apr 10, 2013
 *      Author: martin
 */

#ifndef TRANSITIONPDA_H_
#define TRANSITIONPDA_H_

#include "../Transition.h"
#include "../../alphabet/Symbol.h"
#include <list>

namespace automaton {

using namespace std;
using namespace alphabet;

class TransitionPDA: public Transition {
protected:
	Symbol input;
	list<Symbol> pop;
	list<Symbol> push;

public:
	TransitionPDA(const State& from, const Symbol& input, const State& to);
	TransitionPDA(const State& from, const Symbol& input, const State& to, const list<Symbol>& pop,
			const list<Symbol>& push);

	void setInput(const Symbol& input);
	const Symbol& getInput() const;
	void setPop(const list<Symbol>& pop);
	const list<Symbol>& getPop() const;
	void setPush(const list<Symbol>& push);
	const list<Symbol>& getPush() const;

	bool operator <(const TransitionPDA& other) const;
	bool operator ==(const TransitionPDA& other) const;
	bool operator !=(const TransitionPDA& other) const;

	std::ostream& operator>>(std::ostream& out) const;
};

} /* namespace automaton */
#endif /* TRANSITIONPDA_H_ */
