/*
 * Transition.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: martin
 */

#include "Transition.h"

namespace automaton {

Transition::Transition(const State& current, const State& next) :
		from(current), to(next) {

}

Transition::~Transition() {

}
void Transition::setFrom(const State& state) {
	from = state;
}

const State& Transition::getFrom() const {
	return from;
}

void Transition::setTo(const State& state) {
	to = state;
}

const State& Transition::getTo() const {
	return to;
}

bool Transition::containsState(const State& state) const {
	return from == state || to == state;
}

std::ostream& operator<<(std::ostream& out, const Transition& transition) {
	transition >> out;
	return out;
}

} /* namespace automaton */
