/*
 * RegExpFactory.cpp
 *
 *  Created on: Jan 1, 2014
 *      Author: Martin Zak
 */

#include <iostream>

#include "../sax/SaxInterface.h"
#include "RegExpFactory.h"
#include "../regexp/RegExpFromXMLParser.h"

namespace regexp {

RegExp RegExpFactory::fromFile(const std::string& filename) {
	std::list<sax::Token> tokens;
	sax::SaxInterface::parseFile(filename, tokens);
	return parse(tokens);
}

RegExp RegExpFactory::fromString(const std::string& str) {
	std::list<sax::Token> tokens;
	sax::SaxInterface::parseMemory(str, tokens);
	return parse(tokens);
}

RegExp RegExpFactory::fromStdin() {
	return RegExpFactory::fromStream(std::cin);
}

RegExp RegExpFactory::fromStream(std::istream& in) {
	std::string input(std::istreambuf_iterator<char>(in), (std::istreambuf_iterator<char>()));
	return RegExpFactory::fromString(input);
}

RegExp RegExpFactory::parse(std::list<sax::Token> tokens) {
	RegExpFromXMLParser parser;
	return parser.parse(tokens);
}

} /* namespace regexp */
