/*
 * RegExpEmpty.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "RegExpEmpty.h"

namespace regexp {

RegExpEmpty::RegExpEmpty() {
}

RegExpElement* RegExpEmpty::clone() const {
	return new RegExpEmpty(*this);
}

RegExpElement* RegExpEmpty::plunder() && {
	return new RegExpEmpty(std::move(*this));
}

bool RegExpEmpty::operator<(const RegExpElement& other) const {
	return other > *this;
}

bool RegExpEmpty::operator==(const RegExpElement& other) const {
	return other == *this;
}

bool RegExpEmpty::operator>(const RegExpElement& other) const {
	return other < *this;
}


bool RegExpEmpty::operator<(const Concatenation&) const {
	return true;
}

bool RegExpEmpty::operator<(const Alternation&) const {
	return true;
}

bool RegExpEmpty::operator<(const Iteration&) const {
	return true;
}

bool RegExpEmpty::operator<(const RegExpSymbol&) const {
	return true;
}

bool RegExpEmpty::operator<(const RegExpEpsilon&) const {
	return true;
}

bool RegExpEmpty::operator==(const RegExpEmpty&) const {
	return true;
}

void RegExpEmpty::operator>>(std::ostream& out) const {
	out << "(RegExpEmpty)";
}

void RegExpEmpty::getAlphabet( std::set<alphabet::Symbol> & alphabet ) const {

}

bool RegExpEmpty::containsEmptyString() const {
	return false;
}

bool RegExpEmpty::isEmpty() const {
	return true;
}

} /* namespace regexp */
