/*
 * RegExpEpsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "RegExpEpsilon.h"

namespace regexp {

RegExpEpsilon::RegExpEpsilon() {
}

RegExpElement* RegExpEpsilon::clone() const {
	return new RegExpEpsilon(*this);
}

RegExpElement* RegExpEpsilon::plunder() && {
	return new RegExpEpsilon(std::move(*this));
}

bool RegExpEpsilon::operator<(const RegExpElement& other) const {
	return other > *this;
}

bool RegExpEpsilon::operator==(const RegExpElement& other) const {
	return other == *this;
}

bool RegExpEpsilon::operator>(const RegExpElement& other) const {
	return other < *this;
}


bool RegExpEpsilon::operator<(const Alternation&) const {
	  return true;
}

bool RegExpEpsilon::operator<(const Concatenation&) const {
	  return true;
}

bool RegExpEpsilon::operator<(const Iteration&) const {
	  return true;
}

bool RegExpEpsilon::operator<(const RegExpSymbol&) const {
	  return true;
}

bool RegExpEpsilon::operator==(const RegExpEpsilon&) const {
	  return true;
}

void RegExpEpsilon::operator>>(std::ostream& out) const {
	out << "(RegExpEpsilon)";
}

void RegExpEpsilon::getAlphabet( std::set<alphabet::Symbol> & alphabet ) const {

}

bool RegExpEpsilon::containsEmptyString() const {
	return true;
}

bool RegExpEpsilon::isEmpty() const {
	return false;
}

} /* namespace regexp */

