/*
 * ParseToken.h
 *
 *  Created on: 9.8.2012
 *      Author: Martin Zak
 */

#ifndef TOKEN_H_
#define TOKEN_H_

#include <string>

namespace sax {

/**
 * Represents part of parsed XML. Can be start of tag, end of tag,
 * tag attribute or array of characters.
 */
class Token {
public:

	enum TokenType {
		START_ELEMENT, END_ELEMENT, ATTRIBUTE, CHARACTER
	};

private:
	std::string data;
	TokenType type;

public:
	Token(const std::string&, const TokenType);
	virtual ~Token();

	/**
	 * @return name of the tag or characters read
	 */
	const std::string& getData() const;

	/**
	 * @return type of the token - star of the tag, end of the tag, attribute
	 * of the tag or characters
	 */
	TokenType getType() const;
};

} /* namespace sax */

#endif /* TOKEN_H_ */
